VERSION 2.00
Begin Form Form1 
   Caption         =   "Is App Running?"
   ClientHeight    =   1275
   ClientLeft      =   1095
   ClientTop       =   1500
   ClientWidth     =   3510
   Height          =   1680
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   1275
   ScaleWidth      =   3510
   Top             =   1155
   Width           =   3630
   Begin CommandButton Command2 
      Cancel          =   -1  'True
      Caption         =   "E&xit"
      Height          =   315
      Left            =   1980
      TabIndex        =   3
      Top             =   810
      Width           =   1335
   End
   Begin TextBox Text1 
      Height          =   315
      Left            =   180
      TabIndex        =   1
      Text            =   "Text1"
      Top             =   390
      Width           =   3135
   End
   Begin CommandButton Command1 
      Caption         =   "&Switch To"
      Default         =   -1  'True
      Height          =   315
      Left            =   180
      TabIndex        =   2
      Top             =   810
      Width           =   1335
   End
   Begin Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "&Name of EXEcutable to look for:"
      Height          =   195
      Left            =   210
      TabIndex        =   0
      Top             =   150
      Width           =   2760
   End
End
Option Explicit

' Win16 Declarations
Declare Function ShowWindow Lib "User" (ByVal hWnd As Integer, ByVal nCmdShow As Integer) As Integer
Declare Function FindWindow Lib "User" (ByVal lpClassName As Any, ByVal lpWindowName As Any) As Integer
Declare Function GetParent Lib "User" (ByVal hWnd%) As Integer
Declare Function GetWindow Lib "User" (ByVal hWnd%, ByVal wCmd%) As Integer
Declare Function GetWindowWord Lib "User" (ByVal hWnd%, ByVal nIndex%) As Integer
Declare Function GetModuleFileName Lib "Kernel" (ByVal hModule As Integer, ByVal lpFilename As String, ByVal nSize As Integer) As Integer
Declare Function SetActiveWindow Lib "User" (ByVal hWnd As Integer) As Integer

' ShowWindow() Commands
Const SW_HIDE = 0
Const SW_SHOWNORMAL = 1
Const SW_NORMAL = 1
Const SW_SHOWMINIMIZED = 2
Const SW_SHOWMAXIMIZED = 3
Const SW_MAXIMIZE = 3
Const SW_SHOWNOACTIVATE = 4
Const SW_SHOW = 5
Const SW_MINIMIZE = 6
Const SW_SHOWMINNOACTIVE = 7
Const SW_SHOWNA = 8
Const SW_RESTORE = 9

' GetWindow and GetWindowWord Constants
Const GWW_HINSTANCE = -6
Const GW_HWNDNEXT = 2

Sub Command1_Click ()
   Dim Module$
   '
   ' Use Text1 as input to the ShowModule function.
   '
   Module = Trim$(Text1.Text)
   If ShowModule(Module$) = False Then
      MsgBox Module & " not running"
   End If
End Sub

Sub Command2_Click ()
   Unload Me
End Sub

Sub Form_Load ()
   '
   ' Position form and setup controls.
   '
   Text1.Text = ""
   Me.Move (Screen.Width - Me.Width) \ 2, (Screen.Height - Me.Height) \ 2
End Sub

Function GetHWndByInst (hInstFind%) As Integer
   Dim hWndTmp%
   '
   ' Find first window and loop through all subsequent
   ' windows in master window list.
   '
   hWndTmp = FindWindow(0&, 0&)
   Do Until hWndTmp = 0
      '
      ' Make sure this window has no parent.
      '
      If GetParent(hWndTmp) = 0 Then
         '
         ' Compare passed hInst against this window's hInst.
         ' If a match, then return hWnd for current window.
         '
         If hInstFind% = GetWindowWord(hWndTmp, GWW_HINSTANCE) Then
            GetHWndByInst = hWndTmp
            Exit Do
         End If
      End If
      '
      ' Get next window in master window list and continue.
      '
      hWndTmp = GetWindow(hWndTmp, GW_HWNDNEXT)
   Loop
End Function

Function GetModuleHWnd (ByVal Module$) As Integer
   Dim hWndTmp%
   Dim hInstTmp%
   Dim ModTmp$
   Dim nRet%
   '
   ' Clean up module name, and create buffer to
   ' receive names of running modules.
   '
   Module = Trim$(UCase$(Module))
   ModTmp = Space$(128)
   '
   ' Find first window and loop through all subsequent
   ' windows in master window list.
   '
   hWndTmp = FindWindow(0&, 0&)
   Do Until hWndTmp = 0
      '
      ' Make sure this window has no parent.
      '
      If GetParent(hWndTmp) = 0 Then
         '
         ' Retrieve the instance handle, and use that
         ' to retrieve the module name.
         '
         hInstTmp = GetWindowWord(hWndTmp, GWW_HINSTANCE)
         nRet = GetModuleFileName(hInstTmp, ModTmp, 128)
         '
         ' Compare this window's module name to that
         ' passed in.  Exit if match found.
         '
         If Right$(Left$(ModTmp, nRet), Len(Module)) = Module Then
            GetModuleHWnd = hWndTmp
            Exit Do
         End If
         Debug.Print Left$(ModTmp, nRet)
      End If
      '
      ' Get next window in master window list and continue.
      '
      hWndTmp = GetWindow(hWndTmp, GW_HWNDNEXT)
   Loop
End Function

Function ShowModule (Module$) As Integer
   '
   ' Requires that Module$ include extension,
   ' but path is optional.
   '
   Dim hWndMod%
   Dim nRet%
   '
   ' Retrieve hWnd for passed Module.
   '
   hWndMod = GetModuleHWnd(Module)
   '
   ' If GetModuleHWnd returned 0, then it isn't running.
   ' Otherwise, bring up the requested Module.
   '
   If hWndMod Then
      nRet = ShowWindow(hWndMod, SW_SHOWNORMAL)
      nRet = SetActiveWindow(hWndMod)
      ShowModule = True
   End If
End Function

